<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Bootstrap Flex</title>
	<!-- bootstrap css -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>
	<!-- 
		Flexbox 

		Flexbox is used to manipulate and layout our elements. This can also be used extensively in CSS. However, with bootstrap, we can apply flex faster and easier as we only to need to add a class d-flex to create flex parents and make its children flex items.

		Flex items are not actually inline as we can manipulate the width and height of flex items.

		Flex Direction

		Flex items (flex children),by default, are arranged in a row.

		The default direction of flex items is flex-row

		You can change the direction of flex items as flex-row, flex-row-reverse, flex-column, flex-column-reverse.

		Flex Row Reverse
		Starts our items from the opposite side and reverses the order of our items.

		flex-row starts from left to right (default)
		flex-row-reverse starts from right to left

		Note: You can only use flex utilities such as flex direction, justify content and align items on flex parents.

		Flex Column

		Flex column will arrange our items from top to bottom in a column
			-By default flex items arranged as flex-column will
				-Occupy the full width of its parent
				-Stacked on top of each other.
			-What is the difference between block elements and flex items in flex column?
				-We can use flex utilities as justify-content and align-items on flex items but not on block elements.

		Flex Column Reverse
		Flex column reverse will arrange our items in a column but reverse the order, this time we start from the bottom.

	 -->

	 <h1 class="text-center mt-5">Bootstrap Flex</h1>
	 <!-- flex direction: row -->
	 <h3 class="text-center my-3">Flex Row</h3>
	 <div class="bg-dark d-flex mb-4">
	 	<div class="bg-primary p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-success p-2">Flex Item 3</div>
	 </div>
	 <!-- flex-direction: row reverse -->
	 <h3 class="text-center my-3">Flex Row Reverse</h3>
	 <div class="bg-dark d-flex mb-4 flex-row-reverse">
	 	<div class="bg-primary p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-success p-2">Flex Item 3</div>
	 </div>
	 <!-- flex-direction: column -->
	 <h3 class="text-center my-3">Flex Column</h3>
	 <div class="bg-dark d-flex mb-4 flex-column">
	 	<div class="bg-primary p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-success p-2">Flex Item 3</div>
	 </div>
	 <h3 class="text-center my-3">Span as Flex Column Items</h3>
	 <div class="bg-dark d-flex mb-4 flex-column">
	 	<span class="bg-primary p-2">Span Flex 1</span>
	 	<span class="bg-danger p-2">Span Flex 2</span>
	 	<span class="bg-success p-2">Span Flex 3</span>
	 </div>
	 <!-- flex-direction: flex column reverse -->
	 <h3 class="text-center my-3">Flex Column Reverse</h3>
	 <div class="bg-dark d-flex mb-4 flex-column-reverse">
	 	<div class="bg-primary p-2">Flex Item 1</div>
	 	<div class="bg-danger p-2">Flex Item 2</div>
	 	<div class="bg-success p-2">Flex Item 3</div>
	 </div>

	 <!-- Justify Content -->
	 <h2 class="text-center my-5">Justify Content</h2>
	 <!-- 
			justify-content will allow us to manipulate and layout flex-row items horizontally. 

			However, for flex-column items, justify-content manipulate and layout the flex-column items vertically.

	  -->
	  <h3 class="text-center my-3">Justify Content Start</h3>
	  <!-- 
			justify-content-start is the default value of justify-content for flex items. It will allow us to align our items at the start of the flex items.

			For flex-row, the start is from the left.
			For flex-row-reverse, the start is from the right.
	   -->
	   <div class="bg-dark d-flex flex-row justify-content-start mb-4">
		   	<div class="bg-primary p-2">Flex Item 1</div>
		   	<div class="bg-danger p-2">Flex Item 2</div>
		   	<div class="bg-success p-2">Flex Item 3</div>
	   </div>
	   <div class="bg-dark d-flex flex-row-reverse justify-content-start mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   </div>
	   <h3 class="text-center my-3">Justify Content End</h3>
	   <!-- Aligns our flex-items to where its horizontal alignment ends, for flex-row items, that is from the right. for flex-row-reverse, that is from the left. -->
	   <div class="bg-dark d-flex flex-row justify-content-end mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   </div>
	   <div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   </div>
	   <h3 class="text-center my-3">Justify Content Center</h3>
	   <!-- 
	   		Aligns flex-row and flex-row-reverse items to the center horizontally. 
	   	-->
	   	<div class="bg-dark d-flex flex-row justify-content-center mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   	</div>
	   	<div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   	</div>
	   	<h3 class="text-center my-3">Justify Content Between</h3>
	   	<!-- justify-content-between add/distributes the remaining space in the parent element in between the flex children -->
	   	<div class="bg-dark d-flex flex-row justify-content-between mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   		<div class="bg-info p-2">Flex Item 4</div>
	   		<div class="bg-warning p-2">Flex Item 5</div>
	   	</div>
	   	<div class="bg-dark d-flex flex-row-reverse justify-content-between mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   	</div>
	   	<h3 class="text-center my-3">Justify Content Around</h3>
	   	<!-- 
			Align our items by distributing the remaining space around our items. It will automatically calculate the remaining space and distribute that space evenly around our flex items.
	   	 -->
	   	<div class="bg-dark d-flex flex-row justify-content-around mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   	</div>
	   	<div class="bg-dark d-flex flex-row-reverse justify-content-around mb-4">
	   		<div class="bg-primary p-2">Flex Item 1</div>
	   		<div class="bg-danger p-2">Flex Item 2</div>
	   		<div class="bg-success p-2">Flex Item 3</div>
	   	</div>

	   	<!-- Align-Items -->
	   	<h2 class="text-center my-5">Align Items</h2>
	   	<!-- 
			Allows us to manipulate or layout our items vertically for flex-row and flex-row-reverse items.

			However, for flex-column and flex-column-reverse, this allows us to manipulate or layout our items horizontally.
	   	 -->
	   	 <h3 class="text-center my-3">Align Items Start</h3>
	   	 <!-- 
				allows us to align our flex-row and flex-row-reverse items at the start of the vertical alignment.

				This is the default value of align-items
	   	  -->
	   	  <div class="bg-dark d-flex flex-row align-items-start mb-4" style="height:50vh;">
	   	  		<div class="bg-primary p-2">Flex Item 1</div>
	   	  		<div class="bg-danger p-2">Flex Item 2</div>
	   	  		<div class="bg-success p-2">Flex Item 3</div>
	   	  </div>
	   	  <div class="bg-dark d-flex flex-row-reverse align-items-start mb-4" style="height: 50vh;">
	   	  		<div class="bg-primary p-2">Flex Item 1</div>
	   	  		<div class="bg-danger p-2">Flex Item 2</div>
	   	  		<div class="bg-success p-2">Flex Item 3</div>
	   	  </div>
	   	  <h3 class="text-center my-3">Align Items End</h3>
	   	  <!-- 
				allows us to align our flex-row and flex-row-reverse items at the end of the vertical alignment which is at the bottom of our flex parent.
	   	   -->
	   	   <div class="bg-dark d-flex flex-row align-items-end mb-4" style="height:50vh;">
	   	   		<div class="bg-primary p-2">Flex Item 1</div>
	   	   		<div class="bg-danger p-2">Flex Item 2</div>
	   	   		<div class="bg-success p-2">Flex Item 3</div>
	   	   </div>
	   	   <div class="bg-dark d-flex flex-row-reverse align-items-end mb-4" style="height:50vh;">
	   	   		<div class="bg-primary p-2">Flex Item 1</div>
	   	   		<div class="bg-danger p-2">Flex Item 2</div>
	   	   		<div class="bg-success p-2">Flex Item 3</div>
	   	   </div>
	   	   <h3 class="text-center my-3">Align Items Center</h3>
	   	   <!-- 
				allows us to align our flex-row and flex-row-reverse items centered vertically.			
	   	    -->
	   	    <div class="bg-dark d-flex flex-row align-items-center mb-4" style="height:50vh;">
	   	    	<div class="bg-primary p-2">Flex Item 1</div>
	   	    	<div class="bg-danger p-2">Flex Item 2</div>
	   	    	<div class="bg-success p-2">Flex Item 3</div>
	   	    </div>
	   	    <div class="bg-dark d-flex flex-row-reverse align-items-center mb-4" style="height:50vh;">
	   	    	<div class="bg-primary p-2">Flex Item 1</div>
	   	    	<div class="bg-danger p-2">Flex Item 2</div>
	   	    	<div class="bg-success p-2">Flex Item 3</div>
	   	    </div>
	   	    <h3 class="text-center my-3">
	   	    	Align Items Vertically and Horizontally
	   		</h3>
	   		<!-- 
				With the use of justify-content and align-items we can align our flex items vertically and horizontally
	   		 -->
	   		 <div class="bg-dark d-flex flex-row justify-content-center align-items-center mb-4" style="height:50vh;">
	   		 	<div class="bg-primary p-2">Flex Item 1</div>
	   		 	<div class="bg-danger p-2">Flex Item 2</div>
	   		 	<div class="bg-success p-2">Flex Item 3</div>
	   		 </div>
	   		 <div class="bg-dark d-flex flex-row justify-content-end align-items-end mb-4" style="height:50vh;">
	   		 	<div class="bg-primary p-2">Flex Item 1</div>
	   		 	<div class="bg-danger p-2">Flex Item 2</div>
	   		 	<div class="bg-success p-2">Flex Item 3</div>
	   		 </div>
	   		 <div class="bg-dark d-flex flex-row justify-content-between align-items-center mb-4" style="height:50vh;">
	   		 	<div class="bg-primary p-2">Flex Item 1</div>
	   		 	<div class="bg-danger p-2">Flex Item 2</div>
	   		 	<div class="bg-success p-2">Flex Item 3</div>
	   		 </div>
	   		 <!-- 
					Mini-Activity:

					Add an h3 with the text: Mini-Activity with Flex-Row
						-center the text
						-add a bootstrap size 5 margin at the top and bottom of the element.

					Add a div as a flex parent:
						Add classes to arrange/align our items:
						-Arrange items in a row.
						-Center the items horizontally.
						-Place the flex-row items at the bottom of the flex parent.
						-You can copy the div flex items from our other examples.
						-Add dark bg to the flex parent
						-Add a inline style to add a 50vh height to the flex parent.

					Add a div as a flex parent:
						Add classes to arrange/align our items:
						-Arrange items in a row.
						-Center the items vertically.
						-Align the items horizontally by evenly distributing space around the items.
						-You can copy the div flex items from our other examples.
						-Add dark bg to the flex parent
						-Add a inline style to add a 50vh height to the flex parent.


	   		  -->
	   		  <h3 class="text-center my-5">Mini-Activity with Flex Row</h3>
	   		  <div class="bg-dark d-flex flex-row justify-content-center align-items-end mb-4" style="height:50vh;">
	   		  	<div class="bg-primary p-2">Flex Item 1</div>
	   		  	<div class="bg-danger p-2">Flex Item 2</div>
	   		  	<div class="bg-success p-2">Flex Item 3</div>
	   		  </div>
	   		  <div class="bg-dark d-flex flex-row justify-content-around align-items-center mb-4" style="height:50vh;">
	   		  	<div class="bg-primary p-2">Flex Item 1</div>
	   		  	<div class="bg-danger p-2">Flex Item 2</div>
	   		  	<div class="bg-success p-2">Flex Item 3</div>
	   		  </div>

	   		  <h2 class="text-center my-5">
	   		  	Flex Column with Align Items and Justify Content
	   		  </h2>
	   		  <!-- 
					For flex-column and flex-column-reverse, align-items aligns items horizontally and justify-content is used to align items vertically.
	   		   -->
	   		   <div class="bg-dark d-flex flex-column align-items-center mb-4" style="height:50vh;">
	   		   	 <div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
	   		   	 <div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
	   		   	 <div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	   		   </div>
	   		   <div class="bg-dark d-flex flex-column justify-content-center mb-4" style="height: 50vh;">
	   		   	 <div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
	   		   	 <div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
	   		   	 <div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	   		   </div>
	   		   <div class="bg-dark d-flex flex-column justify-content-between mb-4" style="height: 50vh;">
	   		   	 <div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
	   		   	 <div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
	   		   	 <div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	   		   </div>

	   		   <h2 class="text-center my-5">Flex Wrap</h2>
	   		   <!-- 
					flex-wrap allows us to wrap our flex-items around our flex-parent which means if there is an overflow, the items will be put into the next row/line.

	   		    -->
	   		   <div class="bg-dark d-flex flex-row flex-wrap mb-4">
	   		   	 <div class="bg-primary p-2">Flex Item 1</div>
	   		   	 <div class="bg-danger p-2">Flex Item 2</div>
	   		   	 <div class="bg-success p-2">Flex Item 3</div>

	   		   	 <div class="bg-primary p-2">Flex Item 1</div>
	   		   	 <div class="bg-danger p-2">Flex Item 2</div>
	   		   	 <div class="bg-success p-2">Flex Item 3</div>

	   		   	 <div class="bg-primary p-2">Flex Item 1</div>
	   		   	 <div class="bg-danger p-2">Flex Item 2</div>
	   		   	 <div class="bg-success p-2">Flex Item 3</div>

	   		   	 <div class="bg-primary p-2">Flex Item 1</div>
	   		   	 <div class="bg-danger p-2">Flex Item 2</div>
	   		   	 <div class="bg-success p-2">Flex Item 3</div>
	   		   </div>

	<!-- bootstrap js dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>
